#include <stdio.h>
#include <mpi.h>

/*
 * How to use MPI_Send and MPI_Recv (Blocking Functions) with two processes
 */

void main (int argc, char *argv[]) {
	
	MPI_Status status;
	int myrank, size;
	// the message sender wants to send
	int buf = 125;
	
	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
	if (myrank == 0)
	{
		// I'm the master                          tag  communicator
		int retVal = MPI_Send(&buf, 1, MPI_INT, 1, 555, MPI_COMM_WORLD);
	}
	else if (myrank == 1)
	{
		//I'm the slave                            tag  communicator
		int retVal = MPI_Recv(&buf, 1, MPI_INT, 0, 555, MPI_COMM_WORLD, &status);
		printf("I'm the slave; I received %d from process 0.\n", buf);
	}
	
	MPI_Finalize();
}





