#include <stdio.h>
#include <mpi.h>
#include <unistd.h>

void main (int argc, char *argv[]) {
	
	MPI_Status status;
	int myrank, size;
	// the message sender wants to send
	int MAX = 1024;
	int buf[MAX]; buf[0] = 100;
	
	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
	if (myrank == 0)
	{
		printf("I'm the master: ready to send\n");
		// I'm the master                          tag  communicator
		int retVal = MPI_Send(&buf, MAX, MPI_INT, 1, 555, MPI_COMM_WORLD);
		printf("I'm the master: completed\n");
	}
	else
	{
		// we pretend the slave is very busy
		sleep(10);
		printf("I'm the slave: ready to receive\n");
		//I'm the slave                            tag  communicator
		int retVal = MPI_Recv(&buf, MAX, MPI_INT, 0, 555, MPI_COMM_WORLD, &status);
		printf("I'm the slave; I received %d from process 0.\n", buf[0]);
	}
	
	MPI_Finalize();
}





