#include <stdio.h>
#include <mpi.h>
#include <stdlib.h>

#define MAX 10

void main (int argc, char *argv[]) {
	
	MPI_Status status;
	int myrank, size;
	int buf[MAX];
	
	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
	if (myrank == 0)
	{
		// I'm the master
		for (int i = 0; i < MAX; ++i) buf[i] = 1+rand()%100;
		int retVal = MPI_Send(buf, MAX, MPI_INT, 1, 555, MPI_COMM_WORLD);
	}
	else
	{
		//I'm the slave
		int retVal = MPI_Recv(buf, MAX, MPI_INT, 0, 555, MPI_COMM_WORLD, &status);
		printf("I'm the slave; I received the following values:\n");
		for (int i = 0; i < MAX; ++i) printf("%d\n", buf[i]);
	}
	
	MPI_Finalize();
}





