#include <stdio.h>
#include <mpi.h>
#include <stdlib.h>

#define MAX 11

void initializeArray(int *array, int size)
{
	for (int i = 0; i < size; ++i)
		array[i] = 1+rand()%10;
}

void printArray(int *array, int size)
{
	for (int i = 0; i < size; ++i)
		printf("%d ", array[i]);
	printf("\n");
}

int computeSum(int *array, int start, int end)
{
	int sum = 0;
	for (int i = start; i <= end; ++i)
		sum = sum + array[i];
	return sum;
}

void main (int argc, char *argv[]) {
	
	MPI_Status status;
	int myrank, size, retVal;	
	int sumMaster = 0;
	int sumSlave = 0;
	
	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
	if (myrank == 0)
	{
		// I'm the master
		int buf[MAX];
		initializeArray(buf, MAX);
		printArray(buf, MAX);
		retVal = MPI_Send(buf, MAX, MPI_INT, 1, 555, MPI_COMM_WORLD);
		sumMaster = computeSum(buf, 0, (MAX/2)-1);
		retVal = MPI_Recv(&sumSlave, 1, MPI_INT, 1, 555, MPI_COMM_WORLD, &status);
		printf("La somma degli elementi dell'array è %d\n", sumMaster+sumSlave);
	}
	else
	{
		//I'm the slave
		int buf[MAX];
		retVal = MPI_Recv(buf, MAX, MPI_INT, 0, 555, MPI_COMM_WORLD, &status);
		sumSlave = computeSum(buf, MAX/2, MAX-1);
		retVal = MPI_Send(&sumSlave, 1, MPI_INT, 0, 555, MPI_COMM_WORLD);
	}
	
	MPI_Finalize();
}





