#include <stdio.h>
#include <mpi.h>
#include <stdlib.h>
#include <math.h>

#define N 1000000

double pow2(double d)
{
	return d*d;
}

void main (int argc, char *argv[])
{
	MPI_Status status;
	int myrank, P, retVal;
	int q = 0, r = 0;
	double buff = 0.0;
	
	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
	MPI_Comm_size(MPI_COMM_WORLD, &P);

	double h = 1.0/N;
	int i = myrank+1;
	double sum = 0.0;

	while (i <= N)
	{
		sum = sum + (4*h)/(1+pow2(i*h));
		i = i + P;
	}

	if (myrank == 0)
	{
		for (int p = 1; p < P; ++p)
		{
			MPI_Recv(&buff, 1, MPI_DOUBLE, p, 555, MPI_COMM_WORLD, &status);
			sum = sum + buff;
		}
		printf("%5.30f\n", sum);
	}
	else
	{
		MPI_Send(&sum, 1, MPI_DOUBLE, 0, 555, MPI_COMM_WORLD);
	}

	MPI_Finalize();
}
