#include <stdio.h>
#include <mpi.h>
#include <stdlib.h>
#define MSIZE 50000


void main (int argc, char *argv[])
{
	MPI_Status status;
	int rank, size, tag, to, from;
	int A[MSIZE], B[MSIZE], i;
	
	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	MPI_Comm_size(MPI_COMM_WORLD, &size);

	to = (rank + 1) % size;
	from = (rank + size - 1) % size;
	
	for (i = 0; i < MSIZE; ++i)
		A[i] = rank;

	MPI_Sendrecv(A, MSIZE, MPI_INT, to, 201,	/* sending info */
                     B, MSIZE, MPI_INT, from, 201,	/* receiving info */
		     MPI_COMM_WORLD, &status);

	printf("Proc %d sends %d integers to proc %d\n", rank, MSIZE, to);
	printf("Proc %d receives %d integers from proc %d\n", rank, MSIZE, from);

	MPI_Finalize();
}
