#include <stdio.h>
#include <mpi.h>
#include <stdlib.h>
#include <math.h>

#define N 1000000

double pow2(double d)
{
	return d*d;
}

void main (int argc, char *argv[])
{
	MPI_Status status;
	int myrank, P, retVal;
	int q = 0, r = 0;
	double result = 0.0;
	
	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
	MPI_Comm_size(MPI_COMM_WORLD, &P);

	double h = 1.0/N;
	int i = myrank+1;
	double sum = 0.0;

	while (i <= N)
	{
		sum = sum + (4*h)/(1+pow2(i*h));
		i = i + P;
	}

	// Each process has stored in sum the value to reduce
	MPI_Reduce(&sum, &result, 1, MPI_DOUBLE, MPI_SUM, 0, MPI_COMM_WORLD);
	if (myrank == 0) printf("%5.24f\n", result);

	MPI_Finalize();
}
