#include <stdio.h>
#include <mpi.h>
#include <stdlib.h>

#define MSIZE 100

void main (int argc, char *argv[])
{
	MPI_Status status;
	int myrank, size;

	int i, mpibuffer_lenght;
	double *mpibuffer;
	double matrix[MSIZE];

	/* Start up MPI */
	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
	MPI_Comm_size(MPI_COMM_WORLD, &size);

	if (myrank == 0)
	{
		for (i = 0; i < MSIZE; ++i) matrix[i] = (double) i;
		// computes the size of the buffer considering the overhead introduced by BSEND
		mpibuffer_lenght = (MSIZE * sizeof(double) + MPI_BSEND_OVERHEAD);
		mpibuffer = (double *) malloc(mpibuffer_lenght);
		// attach the buffer
		MPI_Buffer_attach(mpibuffer, mpibuffer_lenght);
		MPI_Bsend(matrix, MSIZE, MPI_DOUBLE, 1, 666, MPI_COMM_WORLD);
		MPI_Buffer_detach(mpibuffer, &mpibuffer_lenght);
	}
	else if (myrank == 1)
	{
		MPI_Recv(matrix, MSIZE, MPI_DOUBLE, 0, 666, MPI_COMM_WORLD, &status);
		printf("Process 1 receives an array of size %d from process 0.\n", MSIZE);
	}

	MPI_Finalize();
}
