#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
#include <unistd.h>
 
/**
 * @brief Illustrates how to use an MPI barrier.
 **/
int main(int argc, char* argv[])
{
    MPI_Init(&argc, &argv);
 
    // Get my rank
    int my_rank;
    MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);

    // we pretend process 1 is very busy, so he waits too much time working on its stuff
    if (my_rank == 1) sleep(10);
    printf("[MPI process %d] I start waiting on the barrier.\n", my_rank);
    MPI_Barrier(MPI_COMM_WORLD);
    printf("[MPI process %d] I know all MPI processes have waited on the barrier.\n", my_rank);
 
    MPI_Finalize();
 
    return EXIT_SUCCESS;
}
