#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
 
int main(int argc, char* argv[])
{
    MPI_Init(&argc, &argv);
 
    // Get my rank in the communicator
    int my_rank;
    MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
 
    int buffer;
    if(my_rank == 0)
    {
	// data to be broadcasted. it can be any type of data (even a vector, of course)
        buffer = 12345;
        printf("[MPI process %d] I am the broadcast root, and send value %d.\n", my_rank, buffer);
    }
    // the MPI_Bcast function is invoked by all processes, either master and all workers
    MPI_Bcast(&buffer, 1, MPI_INT, 0, MPI_COMM_WORLD);
    if(my_rank != 0)
    {
        printf("[MPI process %d] I am a broadcast receiver, and obtained value %d.\n", my_rank, buffer);
    }
 
    MPI_Finalize();
 
    return EXIT_SUCCESS;
}
