#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

#define N 4

void initializeArray(int *array, int size)
{
        for (int i = 0; i < size; ++i)
                array[i] = 1+rand()%10;
}

void printArray(int *array, int size)
{
        for (int i = 0; i < size; ++i)
                printf("%d ", array[i]);
        printf("\n");
}

int main(int argc, char* argv[])
{
    MPI_Init(&argc, &argv);
 
    // Get my rank
    int my_rank;
    MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);

    int size;
    MPI_Comm_size(MPI_COMM_WORLD, &size);

    int buffer_to_send[N];	// buffer used by the all workers
    int buffer_to_recv[N*size];	// larger buffer used by the worker to gather all data
 
    // all processes initialize their own buffer to send
    initializeArray(buffer_to_send, N);

    // Data are gathered by master
    MPI_Gather(buffer_to_send, N, MPI_INT, buffer_to_recv, N, MPI_INT, 0, MPI_COMM_WORLD);

    // master shows compute the gathered data
    if (my_rank == 0) printArray(buffer_to_recv, N*size);
 
    MPI_Finalize();
 
    return EXIT_SUCCESS;
}

